// 2x7_seg_MAX7219_countdown_nn
//

   #include <LedControl.h>

   unsigned long counter = 99999999;                       // initial value for countdown
   unsigned long nextTick;                                 // time to update dounter
   int tickTime = 100;                                     // modify decrement time here - in milliseconds
   
   LedControl lc = LedControl (8,9,7,1);                   //  Arduino pins - DIN, CLK, CS, no.of devices is 1


void setup(){

// Initialize the MAX7219 device
   lc.shutdown (0, false);                                 // wake up display
   lc.setIntensity (0, 4);                                 // set brightness level (0 to 15)
   lc.clearDisplay (0);                                    // clear display register

   nextTick = millis();                                    // first tick will happen right away
   
}

void loop()
{

  if( millis() >= nextTick)                                // if it's time to update counter
  {   
    if( counter >= 0 )                                     // if there are any time units left
    {
     lc.clearDisplay(0);                                   // clear display
     printNum (counter);                                   // write next number
     counter--;                                            // decrement counter 
    }   
   nextTick = millis() + tickTime;                         // tick time in millis 
  } 

  
}


// ================== subroutines ====================================================================



void printNum (unsigned long num)                          // print the generated number to the 8-number display
{
  unsigned long dig = 1;
  unsigned long digCnt = 0;


  if( num > 0 )                                            // if number is greater than zero
  {
   while ( num >= dig )                                    // count # of digits
     {                                           
      dig *= 10;
      digCnt++;
     } 
    
      for(int d=0, dig=10; d < digCnt; d++)                // while more digits
        {
         lc.setDigit(0,d,byte(num%10),false);              // write this digit
         num /= 10;                                        // writing from right to left
        }  
      }
     
    else
      {
       lc.setDigit(0,0,(byte)0,false);                     // just write a zero

  }  

}
